# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section   free

Name:           jackson
Version:        1.4.2
Release:        1%{?dist}
Epoch:          0
Summary:        High-performance JSON processor
Group:          Development/Libraries/Java
License:        Apache Software License 2.0
URL:            http://jackson.codehaus.org/
Source0:        jackson-1.4.2.tgz
# svn export http://svn.codehaus.org/jackson/tags/1.4.2/ jackson-1.4.2
# tar czf jackson-1.4.2.tgz jackson-1.4.2/
Patch0:         jackson-build.patch
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  maven-ant-tasks
BuildRequires:  antlr
BuildRequires:  asm2
BuildRequires:  cglib21
BuildRequires:  cglib
BuildRequires:  cobertura
BuildRequires:  groovy16
BuildRequires:  jaf_1_1_api
BuildRequires:  jakarta-oro
BuildRequires:  jaxb_2_1_api
BuildRequires:  joda-time
BuildRequires:  junit4
BuildRequires:  json
BuildRequires:  log4j
Requires:       java-devel >= 0:1.6.0
Requires:       cglib21
Requires:       cglib
Requires:       groovy16
Requires:       jaf_1_1_api
Requires:       joda-time
Requires:       json
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Jackson is a:
* Streaming (reading, writing)
* FAST (measured to be faster than any other Java json parser
  and data binder)
* Powerful (full data binding for common JDK classes as well
  as any Java bean class, Collection, Map or Enum)
* Zero-dependency (does not rely on other packages beyond JDK)
* Open Source (LGPL or AL)
* Fully conformant
* Extremely configurable
JSON processor (JSON parser + JSON generator) written in Java.
Beyond basic JSON reading/writing (parsing, generating), it
also offers full node-based Tree Model, as well as full OJM
(Object/Json Mapper) data binding functionality.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
%{summary}.

%prep
%setup -q
for j in $(find . -name "*.jar"); do 
    mv $j $j.no
done
%patch0 -b .sav0
mv lib/ant/bndtask-0.2.0.jar.no lib/ant/bndtask-0.2.0.jar
mv lib/jaxrs/jsr311-api-1.0.jar.no lib/jaxrs/jsr311-api-1.0.jar
mv lib/perf/stringtree-json-2.0.5.jar.no lib/perf/stringtree-json-2.0.5.jar
mv lib/perf/json_simple-1.0.2.jar.no lib/perf/json_simple-1.0.2.jar
mv lib/perf/jsontools-core-1.5.jar.no lib/perf/jsontools-core-1.5.jar
mv lib/perf/noggit-1.0-SNAPSHOT.jar.no lib/perf/noggit-1.0-SNAPSHOT.jar
mv lib/jaxb/jaxb-api-2.0.jar.no lib/jaxb/jaxb-api-2.0.jar

ln -s $(build-classpath maven-ant-tasks) lib/ant/maven-ant-tasks-2.0.10.jar
#BUILD/jackson-1.2.0/lib/ant/maven-ant-tasks-2.0.10.jar.no
ln -s $(build-classpath cglib-nodep) lib/ext/cglib/cglib-nodep-2.2.jar
#BUILD/jackson-1.2.0/lib/cglib/cglib-nodep-2.2.jar.no
ln -s $(build-classpath asm2/asm2) lib/cobertura/asm-2.2.1.jar
#BUILD/jackson-1.2.0/lib/cobertura/asm-2.2.1.jar.no
ln -s $(build-classpath asm2/asm2-tree) lib/cobertura/asm-tree-2.2.1.jar
#BUILD/jackson-1.2.0/lib/cobertura/asm-tree-2.2.1.jar.no
ln -s $(build-classpath cobertura) lib/cobertura/cobertura-1.9.jar
#BUILD/jackson-1.2.0/lib/cobertura/cobertura-1.9.jar.no
ln -s $(build-classpath oro) lib/cobertura/jakarta-oro-2.0.8.jar
#BUILD/jackson-1.2.0/lib/cobertura/jakarta-oro-2.0.8.jar.no
ln -s $(build-classpath log4j) lib/cobertura/log4j-1.2.13.jar
#BUILD/jackson-1.2.0/lib/cobertura/log4j-1.2.13.jar.no
ln -s $(build-classpath jaxb_2_1_api) lib/cobertura/jaxb-api-2.0.jar
#BUILD/jackson-1.2.0/lib/jaxb/jaxb-api-2.0.jar.no
ln -s $(build-classpath junit4) lib/junit/junit-4.5.jar
#BUILD/jackson-1.2.0/lib/junit/junit-4.5.jar.no
ln -s $(build-classpath antlr) lib/perf/antlr-2.7.6.jar
#BUILD/jackson-1.2.0/lib/perf/antlr-2.7.6.jar.no
ln -s $(build-classpath json) lib/perf/json-org.jar
#BUILD/jackson-1.2.0/lib/perf/json-org.jar.no
ln -s $(build-classpath antlr) lib/ext/groovy/antlr-2.7.7.jar
#BUILD/jackson-1.4.2/lib/ext/groovy/antlr-2.7.7.jar.no
ln -s $(build-classpath asm2/asm2) lib/ext/groovy/asm-2.2.3.jar
#BUILD/jackson-1.4.2/lib/ext/groovy/asm-2.2.3.jar.no
ln -s $(build-classpath groovy16) lib/ext/groovy/groovy-1.6.5.jar
#BUILD/jackson-1.4.2/lib/ext/groovy/groovy-1.6.5.jar.no
rm src/test/org/codehaus/jackson/map/interop/TestHibernate.java
#ln -s $(build-classpath cglib21-nodep) lib/ext/hibernate/hibernate-cglib-repack-nodep-2.1_3-SNAPSHOT.jar
#BUILD/jackson-1.4.2/lib/ext/hibernate/hibernate-cglib-repack-nodep-2.1_3-SNAPSHOT.jar.no
ln -s $(build-classpath joda-time) lib/ext/joda-time-1.5.2.jar
#BUILD/jackson-1.4.2/lib/ext/joda-time-1.5.2.jar.no
ln -s $(build-classpath jaf_1_0_2_api) lib/jaxb/activation.jar
#BUILD/jackson-1.4.2/lib/jaxb/activation.jar.no


%build
ant all

%install
rm -rf $RPM_BUILD_ROOT

install -d 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 dist/*.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)


# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
for l in jackson-core-asl \
         jackson-core-lgpl \
         jackson-jaxrs \
         jackson-mapper-asl \
         jackson-mapper-lgpl \
         jackson-xc \
         ; do
install -m 644 dist/${l}-%{version}.pom \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-${l}.pom
%add_to_maven_depmap org.codehaus.jackson ${l} %{version} JPP/%{name} ${l}
done

#
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr dist/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}*%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}


%changelog
* Sat Jun 11 2011 Ralph Apel <r.apel@r-apel.de> 0:1.4.2-1
- 1.4.2

* Tue Feb 22 2011 Ralph Apel <r.apel@r-apel.de> 0:1.2.0-1
- First release

